// oclist: produce list of opcodes as an #include file for assembler
// MWA 16 May 2023

#include <string.h>
#include <stdio.h>

#include "../misc/misc.h"
#include "../consts/opcode.h"
#include "../consts/slots.h"
#include "instruct.c"

int main(int argc, char *argv[])
{
    struct {
        int opcode;
        char *name;
    } the_extras[] = {
        oc_MIN_BRANCH_NPRIV, "MIN.BRANCH.NPRIV",
        oc_MAX_BRANCH_NPRIV, "MAX.BRANCH.NPRIV",
        oc_MIN_BRANCH_PRIV, "MIN.BRANCH.PRIV",
        oc_MAX_BRANCH_PRIV, "MAX.BRANCH.PRIV",
        oc_MIN_PRIV, "MIN.PRIV",
    };

    int i;

    printf("// generated by oclist.c for use by assembler\n");
    printf("// yes, the below numbers exactly match opcode.h\n\n");

    for (i=0; i<CARD(the_insts); i++)
        printf("%i, \"%s\",\n", the_insts[i].opcode, the_insts[i].name);

    for (i=0; i<CARD(the_extras); i++)
        printf("%i, \"%s\",\n", the_extras[i].opcode, the_extras[i].name);

    return 0;
}

